import { DVEBuilder } from "../../Interfaces/Builder/DVEBuilder";
import { DVEConstructorCore } from "@divinevoxel/core/Interfaces/Constructor/DVEConstructorCore";
import { DVEFDataCore } from "../../Data/DVEFDataCore.js";
import { DVEFConstructorThreads } from "./DVEFConstructorThreads";
import { DVEPropagation } from "Interfaces/Propagation/DVEPropagation";
import { DVEAnaylzer } from "Interfaces/Anaylzer/DVEAnaylzer";
export type DVEFConstrucotrCoreInitData = {
    builder: DVEBuilder;
    propagation: DVEPropagation;
    analyzer: DVEAnaylzer;
};
export declare class DVEFConstrucotrCore extends DVEConstructorCore {
    static instance: DVEFConstrucotrCore;
    threads: DVEFConstructorThreads;
    data: DVEFDataCore;
    worldGen: {
        worldGen: import("Interfaces/WorldGen/WorldGen.types").WorldGenInterface | null;
        register: {
            MAX_ATTEMPTS: number;
            _requests: Map<string, {
                attempts: number;
                dimension: string;
                chunks: Map<string, [x: number, y: number, z: number]>;
                voxels: [x: number, y: number, z: number, data: import("@divinevoxel/core").RawVoxelData][];
            }>;
            registerRequest(location: import("@divinevoxel/core/Math").LocationData): string;
            addToRequest(registerId: string, location: import("@divinevoxel/core/Math").LocationData, rawData: import("@divinevoxel/core").RawVoxelData): void;
            attemptRequestFullFill(registerId: string): boolean;
        };
        worldBounds: {
            bounds: {
                MinZ: number;
                MaxZ: number;
                MinX: number;
                MaxX: number;
                MinY: number;
                MaxY: number;
            };
            setWorldBounds(minX: number, maxX: number, minZ: number, maxZ: number, minY: number, maxY: number): void;
        };
        _brushes: any[];
        setWorldGen(worldGen: import("Interfaces/WorldGen/WorldGen.types").WorldGenInterface): void;
        generate(data: import("Types/Tasks.types").GenerateTasks, mode: "generate" | "decorate", onDone: Function): Promise<void>;
        getBrush(): import("Contexts/Constructor/Tools/WorldGenBrush").WorldGenBrush;
    };
    builder: DVEBuilder;
    propagation: DVEPropagation;
    analyzer: DVEAnaylzer;
    constructor(data: DVEFConstrucotrCoreInitData);
    init(): Promise<void>;
}
