import type { Vec3Array } from "@divinevoxel/core/Math";
import { RichDataTool } from "../../../Default/Tools/Data/RichDataTool.js";
import { BrushTool } from "../../../Default/Tools/Brush/Brush.js";
export declare class WorldGenBrush extends BrushTool {
    constructor();
    requestsId: "";
    tasks: {
        rebuildQueMap: Map<string, boolean>;
        comm: import("@divinestar/threads").CommBase;
        priority: import("../../../Types/Tasks.types.js").Priorities;
        LOD: number;
        syncQueue: import("@divinevoxel/core/Math").LocationData[];
        aSyncQueue: import("@divinevoxel/core/Math").LocationData[];
        buildMode: "sync" | "async";
        buildTasks: import("../../../Types/Tasks.types.js").PriorityTask<import("../../../Types/Tasks.types.js").BuildTasks>;
        rebuildTasks: import("../../../Types/Tasks.types.js").AddToRebuildQueue;
        tasksType: string;
        origin: import("@divinevoxel/core/Math").LocationData;
        data: null;
        buildQueue: string;
        originThread: string;
        queues: {
            flow: {
                update: {
                    queue: number[][];
                    map: import("Util/VisistedMap.js").VisitedMap;
                };
                remove: {
                    queue: number[][];
                    map: import("Util/VisistedMap.js").VisitedMap;
                    noRemoveMap: import("Util/VisistedMap.js").VisitedMap;
                };
            };
            rgb: {
                update: number[];
                remove: number[];
                map: import("Util/VisistedMap.js").VisitedMap;
            };
            sun: {
                update: number[];
                remove: number[];
                updateMap: import("Util/VisistedMap.js").VisitedMap;
                remvoeMap: import("Util/VisistedMap.js").VisitedMap;
            };
        };
        start(): any;
        stop(): any;
        setPriority(priority: import("../../../Types/Tasks.types.js").Priorities): any;
        getData(): null;
        getOriginThread(): import("@divinevoxel/core/Math").LocationData;
        getBuildQueue(): string;
        getOrigin(): import("@divinevoxel/core/Math").LocationData;
        needsRebuild(): boolean;
        needsToUpdateOriginThread(): boolean;
        setBuldMode(mode: "sync" | "async"): any;
        addToRebuildQueue(x: number, y: number, z: number): boolean;
        addNeighborsToRebuildQueue(x: number, y: number, z: number): false | any | undefined;
        runRebuildQueue(): any;
        clear(): void;
    };
    richData: RichDataTool;
    paint(): this;
    erease(): void;
    runUpdates(): void;
    worldAlloc(start: Vec3Array, end: Vec3Array): Promise<boolean>;
    worldDealloc(start: Vec3Array, end: Vec3Array): Promise<boolean>;
}
