import { WorldGenBrush } from "../Tools/WorldGenBrush.js";
import { WorldGenInterface } from "../../../Interfaces/WorldGen/WorldGen.types.js";
import { GenerateTasks } from "../../../Types/Tasks.types.js";
export declare const WorldGeneration: {
    worldGen: WorldGenInterface | null;
    register: {
        MAX_ATTEMPTS: number;
        _requests: Map<string, {
            attempts: number;
            dimension: string;
            chunks: Map<string, [x: number, y: number, z: number]>;
            voxels: [x: number, y: number, z: number, data: import("@divinevoxel/core").RawVoxelData][];
        }>;
        registerRequest(location: import("@divinevoxel/core/Math/index.js").LocationData): string;
        addToRequest(registerId: string, location: import("@divinevoxel/core/Math/index.js").LocationData, rawData: import("@divinevoxel/core").RawVoxelData): void;
        attemptRequestFullFill(registerId: string): boolean;
    };
    worldBounds: {
        bounds: {
            MinZ: number;
            MaxZ: number;
            MinX: number;
            MaxX: number;
            MinY: number;
            MaxY: number;
        };
        setWorldBounds(minX: number, maxX: number, minZ: number, maxZ: number, minY: number, maxY: number): void;
    };
    _brushes: any[];
    setWorldGen(worldGen: WorldGenInterface): void;
    generate(data: GenerateTasks, mode: "generate" | "decorate", onDone: Function): Promise<void>;
    getBrush(): WorldGenBrush;
};
