import type { LocationData } from "@divinevoxel/core/Math";
import { RegionDataTool } from "../../../Default/Tools/Data/WorldData/RegionDataTool.js";
import { ColumnDataTool } from "../../../Default/Tools/Data/WorldData/ColumnDataTool.js";
import { ChunkDataTool } from "../../../Default/Tools/Data/WorldData/ChunkDataTool.js";
export declare class WorldDataSerialize {
    regions: RegionDataTool;
    columns: ColumnDataTool;
    chunks: ChunkDataTool;
    serializeRegion(location: LocationData): false | [location: LocationData, buffer: ArrayBuffer][];
    serializeColumn(location: LocationData): false | Uint8Array;
    deSerializeRegion(regionBuffers: ArrayBuffer[] | SharedArrayBuffer[]): void;
    deSerializeColumn(columnBuffer: ArrayBuffer | SharedArrayBuffer): {
        column: SharedArrayBuffer;
        chunks: SharedArrayBuffer[];
    };
    _readDataIntoBuffer(offset: number, target: Uint8Array, source: ArrayBuffer | SharedArrayBuffer, sourceOffset?: number, sourceLength?: number): number;
}
