import { DataTool } from "../../Default/Tools/Data/DataTool.js";
import { DVEDataCore } from "@divinevoxel/core/Interfaces/Data/DVEDataCore.js";
import { RichDataTool } from "../../Default/Tools/Data/RichDataTool.js";
import { NexusThreads } from "./Threads/NexusTheads.js";
export type DivineVoxelEngineNexusInitData = {
    data: DVEDataCore;
};
export declare class DivineVoxelEngineNexus {
    static instance: DivineVoxelEngineNexus;
    environment: "node" | "browser";
    TC: {
        threadNumber: number;
        threadName: string;
        environment: "node" | "browser";
        _comms: Record<string, import("@divinestar/threads/").CommBase>;
        _commManageras: Record<string, import("@divinestar/threads/").CommManager>;
        _queues: Map<string, Map<string, import("@divinestar/threads/Queue/SyncedQueue.js").SyncedQueue>>;
        parent: import("@divinestar/threads/").CommBase;
        internal: {
            _tasks: Map<number, Map<number, any>>;
            registerTasks(headID: number, taskId: number, run: any): void;
            isInternal(data: any): boolean;
            runInternal(data: any, event: any): false | undefined;
        };
        __initalized: boolean;
        __expectedPorts: Record<string, boolean>;
        crypto: Crypto;
        $INIT(threadName: string, threadParentName: string): Promise<void>;
        getSyncedQueue(threadId: string, queueId: string): import("@divinestar/threads/Queue/SyncedQueue.js").SyncedQueue | undefined;
        addComm(comm: import("@divinestar/threads/").CommBase): void;
        createComm<T>(name: string, mergeObject?: T | undefined): T & import("@divinestar/threads/").CommBase;
        createCommManager(data: import("@divinestar/threads/Meta/Manager/Manager.types.js").CommManagerData): import("@divinestar/threads/").CommManager;
        getComm(id: string): import("@divinestar/threads/").CommBase;
        getCommManager(id: string): import("@divinestar/threads/").CommManager;
        getWorkerPort(): Promise<any>;
        registerTasks<T_1>(id: string | number, run: (data: T_1, onDone?: ((data?: any, transfers?: any) => void) | undefined) => void, mode?: "async" | "deferred" | undefined): void;
        onDataSync<T_2, K>(dataType: string | number, onSync?: ((data: T_2) => void) | undefined, onUnSync?: ((data: K) => void) | undefined): any;
    };
    data: DVEDataCore;
    threads: NexusThreads;
    constructor(data: DivineVoxelEngineNexusInitData);
    init(): Promise<void>;
    getRichDataTool(): RichDataTool;
    getDataTool(): DataTool;
}
