import { DVERenderCore } from "@divinevoxel/core/Interfaces/Render/DVERenderCore";
import { DVEFDataCore } from "../../Data/DVEFDataCore";
import { DVEFRenderThreads } from "./DVEFRenderThreads";
export class DVEFRenderCore extends DVERenderCore {
    threads = new DVEFRenderThreads();
    data = new DVEFDataCore();
    constructor(props = {}) {
        super();
        if (props.nexusWorker) {
            this.threads.nexus.setPort(props.nexusWorker);
            this.threads.addComm(this.threads.nexus);
        }
        if (props.richWorldWorker) {
            this.threads.richWorld.setPort(props.richWorldWorker);
            this.threads.addComm(this.threads.richWorld);
        }
        if (props.dataLoaderWorker) {
            this.threads.dataLoader.setPort(props.dataLoaderWorker);
            this.threads.addComm(this.threads.dataLoader);
        }
    }
}
