import { DataSync } from "@divinevoxel/core/Interfaces/World/Data/DataSync.js";
import { DataSyncNode } from "@divinevoxel/core/Interfaces/World/Data/DataSyncNode.js";
import type { LocationData } from "@divinevoxel/core/Math/index.js";
import type { WorldDataSync } from "../../Data/Types/DataSync.types.js";
import type { DimensionData } from "../../Data/Types/DimensionData.types.js";
import type { RemoteTagManagerInitData } from "@divinestar/binary/";
import { Chunk, Column, Region } from "../../Data/World/Classes/index.js";
export declare class DVEFDataSync extends DataSync {
    constructor();
    worldDataTags: {
        chunk: DataSyncNode<void, RemoteTagManagerInitData, void, false>;
        column: DataSyncNode<void, RemoteTagManagerInitData, void, false>;
        region: DataSyncNode<void, [RemoteTagManagerInitData, RemoteTagManagerInitData], void, false>;
    };
    worldData: {
        dimesnion: DataSyncNode<string | number, DimensionData, string | number, boolean>;
        chunk: DataSyncNode<LocationData, [LocationData, Chunk], LocationData, LocationData>;
        column: DataSyncNode<LocationData, [LocationData, Column], LocationData, LocationData>;
        region: DataSyncNode<LocationData, [LocationData, Region], LocationData, LocationData>;
        regionHeader: DataSyncNode<LocationData, WorldDataSync, LocationData, boolean>;
    };
}
