import { DVEWorldCore } from "@divinevoxel/core/Interfaces/World/DVEWorldCore";
import { DVEFWorldThreads } from "./DVEFWorldThreads";
import { DVEFDataSync } from "./DVEFDataSync";
import { DVEFoundationTasksQueues } from "./Tasks/DVEFoundationTasksQueues";
import { BuilderTool } from "../../Default/Tools/Build/BuilderTool";
import { DataTool } from "../../Default/Tools/Data/DataTool";
import { RegionDataTool } from "../../Default/Tools/Data/WorldData/RegionDataTool";
import { ColumnDataTool } from "../../Default/Tools/Data/WorldData/ColumnDataTool";
import { HeightMapTool } from "../../Default/Tools/Data/WorldData/HeightMapTool";
import { TaskTool } from "../../Default/Tools/Tasks/TasksTool";
import { DataLoaderTool } from "../../Default/Tools/Loader/DataLoaderTool";
import { RichDataTool } from "../../Default/Tools/Data/RichDataTool";
import { ChunkDataTool } from "../../Default/Tools/Data/WorldData/ChunkDataTool";
import { DVEFDataReigster } from "./Data/DVEFDataRegister";
import { DVEFDataTags } from "./Data/DVEFDataTags";
import { AdvancedBrush } from "../../Default/Tools/Brush/AdvancedBrushTool";
export type DVEFWorldCoreProps = {
    nexusEnabled?: boolean;
    richWorldEnabled?: boolean;
    dataLoaderEnabled?: boolean;
};
export declare class DVEFWorldCore extends DVEWorldCore {
    props: DVEFWorldCoreProps;
    static instance: DVEFWorldCore;
    threads: DVEFWorldThreads;
    dataSync: DVEFDataSync;
    queues: DVEFoundationTasksQueues;
    dataRegiser: DVEFDataReigster;
    dataTagBulders: DVEFDataTags;
    constructor(props?: DVEFWorldCoreProps);
    init(): Promise<void>;
    getAllTools(): {
        brush: AdvancedBrush;
        builder: BuilderTool;
        data: DataTool;
        chunkData: ChunkDataTool;
        columnData: ColumnDataTool;
        regonData: RegionDataTool;
        heightMap: HeightMapTool;
        tasks: TaskTool;
    };
    getBrush(): AdvancedBrush;
    getBuilder(): BuilderTool;
    getDataTool(): DataTool;
    getRegionTool(): RegionDataTool;
    getChunkDataTool(): ChunkDataTool;
    getColumnDataTool(): ColumnDataTool;
    getHeightMapTool(): HeightMapTool;
    getTasksTool(): TaskTool;
    getDataLoaderTool(): DataLoaderTool;
    getRichDataTool(): RichDataTool;
}
