import { DimensionsRegister } from "./World/DimensionsRegister.js";
import { WorldPainter } from "./World/WorldPainter.js";
import { WorldRegister } from "./World/WorldRegister.js";
import { DVEFDataSyncNode } from "./DVEFDataSyncNode.js";
import { DataManager } from "@divinevoxel/core/Interfaces/Data/DataManager.js";
export declare class DVEFDataManager extends DataManager {
    world: WorldPainter;
    dataSync: DVEFDataSyncNode;
    registers: {
        dimensions: typeof DimensionsRegister;
        world: WorldRegister;
        regionHeader: {
            _headers: Map<string, Map<string, {
                data: DataView;
                buffer: SharedArrayBuffer;
            }>>;
            remove(location: import("@divinevoxel/core/Math/index.js").LocationData): boolean;
            add(location: import("@divinevoxel/core/Math/index.js").LocationData, buffer: SharedArrayBuffer): void;
            get(location: import("@divinevoxel/core/Math/index.js").LocationData): false | {
                data: DataView;
                buffer: SharedArrayBuffer;
            } | undefined;
            isStored(location: import("@divinevoxel/core/Math/index.js").LocationData): 1 | -1 | 0;
        };
    };
    worldDataTags: {
        chunks: import("@divinestar/binary").RemoteTagManager;
        column: import("@divinestar/binary").RemoteTagManager;
        region: import("@divinestar/binary").RemoteTagManager;
    };
}
