import { Observable } from "@divinestar/utils/Observers/index.js";
import { AsyncPipeline, Pipeline } from "@divinestar/utils/Pipelines/";
import type { LocationData } from "@divinevoxel/core/Math/index.js";
import { DimensionData } from "./Types/DimensionData.types";
import { EngineSettingsData } from "@divinevoxel/core/Types/EngineSettings.types";
import { Chunk, Column, Region } from "./World/Classes/index.js";
export declare const DataHooks: {
    dimension: {
        onRegisterDimension: Pipeline<DimensionData>;
    };
    chunk: {
        onGetAsync: AsyncPipeline<{
            location: LocationData;
            chunk: Chunk | null;
        }>;
        onGetSync: Pipeline<{
            location: LocationData;
            chunk: Chunk | null;
        }>;
        onNew: Observable<LocationData>;
        onRemove: Observable<LocationData>;
    };
    column: {
        onGetAsync: AsyncPipeline<{
            location: LocationData;
            column: Column | null;
        }>;
        onGetSync: Pipeline<{
            location: LocationData;
            column: Column | null;
        }>;
        onNew: Observable<LocationData>;
        onRemove: Observable<LocationData>;
    };
    region: {
        onGetAsync: AsyncPipeline<{
            location: LocationData;
            region: Region | null;
        }>;
        onGetSync: Pipeline<{
            location: LocationData;
            region: Region | null;
        }>;
        onNew: Observable<LocationData>;
        onRemove: Observable<LocationData>;
    };
    paint: {
        onAddToRGBUpdate: Observable<LocationData>;
        onRichVoxelPaint: Observable<[id: string, location: LocationData]>;
    };
    settingsSynced: Observable<EngineSettingsData>;
};
