var StateMasks;
(function (StateMasks) {
    StateMasks[StateMasks["Level"] = 15] = "Level";
    StateMasks[StateMasks["LevelState"] = 48] = "LevelState";
    StateMasks[StateMasks["ShapeState"] = 65472] = "ShapeState";
})(StateMasks || (StateMasks = {}));
/**# Voxel Reader
 * ---
 * Used to decode voxel state data.
 */
export const VoxelStateReader = {
    getLevel(stateData) {
        return stateData & StateMasks.Level;
    },
    setLevel(stateData, level) {
        return (stateData & ~StateMasks.Level) | level;
    },
    getLevelState(stateData) {
        return (stateData & StateMasks.LevelState) >> 4;
    },
    setLevelState(stateData, levelState) {
        return (stateData & ~StateMasks.LevelState) | (levelState << 4);
    },
    getShapeState(voxelData) {
        return (voxelData & StateMasks.ShapeState) >> 6;
    },
    setShapeState(voxelData, shapeState) {
        return (voxelData & ~StateMasks.ShapeState) | (shapeState << 6);
    },
};
