import { RemoteTagManager } from "@divinestar/binary/";
import { DVEMessageHeader, WorldDataHeaders, } from "../../Constants/DataHeaders.js";
export class Column {
    static Tags = new RemoteTagManager("column-tags");
    static CreateNew(data) {
        const stateBuffer = new SharedArrayBuffer(Column.Tags.tagSize);
        Column.Tags.setBuffer(stateBuffer);
        Column.Tags.setTag("#dve_header", DVEMessageHeader);
        Column.Tags.setTag("#dve_data_type", WorldDataHeaders.column);
        return new Column({
            stateBuffer,
            chunks: [],
            ...data,
        });
    }
    static AddNew(data) {
        return new Column({
            ...data
        });
    }
    columnState;
    constructor(data) {
        this.columnState = new DataView(data.stateBuffer);
        return Object.assign(this, data);
    }
}
