import { RemoteTagManager } from "@divinestar/binary/";
import { DVEMessageHeader, WorldDataHeaders, } from "../../Constants/DataHeaders.js";
export class Region {
    static CreateNew() {
        const stateBuffer = new SharedArrayBuffer(Region.Tags.tagSize);
        Region.Tags.setBuffer(stateBuffer);
        Region.Tags.setTag("#dve_header", DVEMessageHeader);
        Region.Tags.setTag("#dve_data_type", WorldDataHeaders.region);
        return new Region({
            stateBuffer,
            columns: new Map(),
        });
    }
    static AddNew(data) {
        return new Region({
            ...data,
        });
    }
    static Tags = new RemoteTagManager("region-tags");
    regionState;
    constructor(data) {
        this.regionState = new DataView(data.stateBuffer);
        return Object.assign(data, this);
    }
    *getColumns() {
        for (const [key, column] of this.columns) {
            yield column;
        }
    }
}
