import type { ConstructorTextureData } from "../../../../Textures/Constructor.types";
import type { DirectionNames } from "@divinevoxel/core/Types/Util.types.js";
import { SimpleBoxVoxelConstructor } from "./Classes/Box/SimpleBox.constructor.js";
import { PillarBoxVoxelConstructor, PillarBoxVoxelConstructorData } from "./Classes/Box/PillarBox.constructor.js";
import { SimpleLiquidConstructor } from "./Classes/Liquid/SimpleLiquid.constructor.js";
import { SimplePanelVoxelConstructor } from "./Classes/Panel/SimplePanel.constructor.js";
import { SimpleStairVoxelConstructor } from "./Classes/Stair/SimpleStair.constructor.js";
import { VoxelConstructor } from "./Classes/VoxelConstructor.js";
import { SimpleCrossedPanelVoxelConstructor } from "./Classes/Panel/SimpleCrossedPanel.constructor.js";
import { UtilMap } from "../../../../Util/UtilMap";
export declare const VoxelConstructors: {
    constructors: UtilMap<string, VoxelConstructor>;
    get(id: string): VoxelConstructor;
    registerVoxel(voxel: VoxelConstructor | VoxelConstructor[]): void;
    defaults: {
        box: {
            simple(id: string, textures: ConstructorTextureData | Record<DirectionNames, ConstructorTextureData>): SimpleBoxVoxelConstructor;
            pillar(id: string, textures: PillarBoxVoxelConstructorData): PillarBoxVoxelConstructor;
        };
        stair: {
            simple(id: string, texture: ConstructorTextureData): SimpleStairVoxelConstructor;
        };
        panel: {
            simple(id: string, texture: ConstructorTextureData): SimplePanelVoxelConstructor;
        };
        crossedPanel: {
            simple(id: string, texture: ConstructorTextureData): SimpleCrossedPanelVoxelConstructor;
        };
        liquid: {
            simple(id: string, textures: [ConstructorTextureData, ConstructorTextureData]): SimpleLiquidConstructor;
        };
    };
};
