import { Position3Matrix, Vec2Array, Vec3Array } from "@divinevoxel/core/Math";
import { VoxelMesherDataTool } from "../Tools/VoxelMesherDataTool";
import { QuadVertexVec3Data, QuadUVData, QuadVertexFloatData } from "./Geometry.types";
export declare class VoxelGeometry {
    static addTriangle(tool: VoxelMesherDataTool, origin: Position3Matrix, points: [Vec3Array, Vec3Array, Vec3Array], [[u1, v1], [u2, v2], [u3, v3]]: [Vec2Array, Vec2Array, Vec2Array]): void;
    static addQuad(tool: VoxelMesherDataTool, origin: Position3Matrix, doubleSided: boolean, points: QuadVertexVec3Data, [[u1, v1], [u2, v2], [u3, v3], [u4, v4]]: QuadUVData, normalOverrides?: QuadVertexVec3Data, ao?: QuadVertexFloatData, light?: QuadVertexFloatData, animations?: QuadVertexFloatData, textureIndex?: number, overlayTextures?: QuadVertexFloatData): void;
    static addSimpleQuad(tool: VoxelMesherDataTool, origin: Position3Matrix, orientation: 0 | 1, flip: boolean, points: [Vec3Array, Vec3Array], [[u1, v1], [u2, v2], [u3, v3], [u4, v4]]: QuadUVData): void;
}
