import type { FaceDataOverride } from "../Types/Override.types";
import type { DirectionNames } from "@divinevoxel/core/Types/Util.types.js";
import { BuilderDataTool } from "./BuilderDataTool.js";
import { MesherDataTool } from "@divinevoxel/core/Meshing/Tools/MesherDataTools";
import { QuadVertexData } from "@divinevoxel/core/Meshing/";
import { VoxelTemplateDataTool } from "./VoxelTemplateDataTool.js";
export declare class VoxelMesherDataTool extends MesherDataTool {
    template: VoxelTemplateDataTool;
    voxel: BuilderDataTool;
    nVoxel: BuilderDataTool;
    faceDataOverride: FaceDataOverride;
    constructor();
    calculateLight(direction: DirectionNames, ignoreAO?: boolean): void;
    calculateFlow(): void;
    getWorldLight(): QuadVertexData;
    getWorldAO(): QuadVertexData;
    getWorldLevel(): QuadVertexData;
    getOverlayTextures(): QuadVertexData;
    setTexture(uv: number): this;
    getTexture(): number;
    setFaceFlipped(value: boolean): this;
    isFaceFlipped(): boolean;
    isFaceExposed(face: DirectionNames): boolean;
}
