import type { IWGGeneratorData, IWGSettignsData, IWGTasksData, IWGTasksTypes } from "./Types/IWG.types";
import type { Vec3Array } from "@divinevoxel/core/Math";
import { Generator } from "./Classes/Generator.js";
import { LocationData } from "@divinevoxel/core/Math";
export declare const IWG: {
    tasks: Record<IWGTasksTypes, Map<string, IWGTasksData>>;
    inProgressMap: {
        map: Map<string, string>;
        add(x: number, y: number, z: number, tasks: string): void;
        has(x: number, y: number, z: number): boolean;
        remove(x: number, y: number, z: number): boolean;
    };
    getKey(x: number, y: number, z: number): any;
    generators: Map<string, Generator>;
    addGenerator(data: IWGGeneratorData): Generator;
    getGenerator(id: string): false | Generator;
    removeGenerator(id: string): boolean;
    worldGenUpdate(max?: number): void;
    searchUpdate(): void;
    saveUpdate(max?: number): void;
    registerTasks(type: IWGTasksTypes, tasksData: IWGTasksData): void;
    initalLoad(dimension: string, position: Vec3Array, settings?: IWGSettignsData, onCheck?: (gen: Generator) => void): Promise<void>;
    safeExit(genId: string, onCheck?: (gen: Generator) => void): Promise<false | undefined>;
    teleport(genId: string, location: LocationData, onCheck?: (gen: Generator) => void): Promise<false | undefined>;
};
