export declare const ExplosionManager: {
    runExplosion(tasks: {
        rebuildQueMap: Map<string, boolean>;
        comm: import("@divinestar/threads").CommBase;
        priority: import("Types/Tasks.types.js").Priorities;
        LOD: number;
        syncQueue: import("@divinevoxel/core/Math/index.js").LocationData[];
        aSyncQueue: import("@divinevoxel/core/Math/index.js").LocationData[];
        buildMode: "sync" | "async";
        buildTasks: import("Types/Tasks.types.js").PriorityTask<import("Types/Tasks.types.js").BuildTasks>;
        rebuildTasks: import("Types/Tasks.types.js").AddToRebuildQueue;
        tasksType: string;
        origin: import("@divinevoxel/core/Math/index.js").LocationData;
        data: number;
        buildQueue: string;
        originThread: string;
        queues: {
            flow: {
                update: {
                    queue: number[][];
                    map: import("Util/VisistedMap.js").VisitedMap;
                };
                remove: {
                    queue: number[][];
                    map: import("Util/VisistedMap.js").VisitedMap;
                    noRemoveMap: import("Util/VisistedMap.js").VisitedMap;
                };
            };
            rgb: {
                update: number[];
                remove: number[];
                map: import("Util/VisistedMap.js").VisitedMap;
            };
            sun: {
                update: number[];
                remove: number[];
                updateMap: import("Util/VisistedMap.js").VisitedMap;
                remvoeMap: import("Util/VisistedMap.js").VisitedMap;
            };
            queue: [x: number, y: number, z: number][];
            map: import("Util/VisistedMap.js").VisitedMap;
        };
        start(): any;
        stop(): any;
        setPriority(priority: import("Types/Tasks.types.js").Priorities): any;
        getData(): number;
        getOriginThread(): import("@divinevoxel/core/Math/index.js").LocationData;
        getBuildQueue(): string;
        getOrigin(): import("@divinevoxel/core/Math/index.js").LocationData;
        needsRebuild(): boolean;
        needsToUpdateOriginThread(): boolean;
        setBuldMode(mode: "sync" | "async"): any;
        addToRebuildQueue(x: number, y: number, z: number): boolean;
        addNeighborsToRebuildQueue(x: number, y: number, z: number): false | any | undefined;
        runRebuildQueue(): any;
        clear(): void;
    }): void;
};
