import { URIShader } from "@divinestar/uri/Shaders/Classes/URIShader.js";
import { UtilMap } from "../../Util/UtilMap.js";
export declare class DVEShaderRegister {
    shaders: UtilMap<string, URIShader>;
    create(shaders: URIShader[]): void;
    get(id: string): URIShader | undefined;
    getBulder(): {
        shaders: {
            _shaders: Map<string, URIShader>;
            create(id: string): URIShader;
        };
        functions: {
            _functions: Map<string, import("@divinestar/uri/Shaders/Types/ShaderData.types.js").ShaderFunctionData<any>>;
            _functionSets: Map<string, string[]>;
            create(id: string, data: import("@divinestar/uri/Shaders/Types/ShaderData.types.js").ShaderFunctionData<any>): void;
            _processFunctinos(id: string, data: import("@divinestar/uri/Shaders/Types/ShaderData.types.js").ShaderFunctionData<any>, shader?: URIShader | null | undefined): string;
            build(id: string, data?: import("@divinestar/uri/Shaders/Types/ShaderData.types.js").ShaderFunctionData<any> | null | undefined, shader?: URIShader | null | undefined, predicate?: ((id: string, type: import("@divinestar/uri/Shaders/Types/ShaderData.types.js").ShaderFunctionData<any>) => boolean) | undefined): string;
        };
        define: {
            _process(data: import("@divinestar/uri/Shaders/Types/ShaderData.types.js").ShaderDefinesData): string;
            build(data: import("@divinestar/uri/Shaders/Types/ShaderData.types.js").ShaderDefinesData | import("@divinestar/uri/Shaders/Types/ShaderData.types.js").ShaderDefinesData[] | Map<string, import("@divinestar/uri/Shaders/Types/ShaderData.types.js").ShaderDefinesData>): string;
        };
        uniforms: {
            _process(data: import("@divinestar/uri/Shaders/Types/ShaderData.types.js").ShaderUniformData): string;
            build(data: import("@divinestar/uri/Shaders/Types/ShaderData.types.js").ShaderUniformData[] | Map<string, import("@divinestar/uri/Shaders/Types/ShaderData.types.js").ShaderUniformData>, predicate?: ((id: string, type: import("@divinestar/uri/Shaders/Types/ShaderData.types.js").ShaderUniformData) => boolean) | undefined): string;
        };
        snippets: {
            _snippets: Map<string, import("@divinestar/uri/Shaders/Types/ShaderData.types.js").ShaderSnippetData<any>>;
            create(data: import("@divinestar/uri/Shaders/Types/ShaderData.types.js").ShaderSnippetData<any>): void;
            override(id: string, data: import("@divinestar/uri/Shaders/Types/ShaderData.types.js").ShaderSnippetData<any>): boolean;
            get(id: string, args?: any): string;
            _process(text: string, shader?: URIShader | undefined): {
                newBody: string;
                foundSnippet: boolean;
            };
            build(text: string, shader?: URIShader | undefined): string;
        };
    };
}
