import type { LocationData } from "@divinevoxel/core/Math";
import { CommBase } from "@divinestar/threads/";
import { ColumnDataTool } from "../Data/WorldData/ColumnDataTool.js";
import { LocationBoundTool } from "../Classes/LocationBoundTool.js";
export declare class DataLoaderTool extends LocationBoundTool {
    static columnDataTool: ColumnDataTool;
    static isEnabled(): boolean;
    mode: "indexdb" | "server" | "both";
    _enabled: boolean;
    dataComm: CommBase;
    constructor();
    _runTask(id: string, location: LocationData, onDone?: Function): void;
    isEnabled(): boolean;
    saveRegion(onDone?: Function): void;
    saveRegionAsync(): Promise<unknown>;
    loadRegion(onDone?: Function): void;
    loadRegionAsync(): Promise<unknown>;
    saveColumn(onDone?: Function): void;
    saveColumnIfNotStored(onDone?: (saved: boolean) => void): boolean | void;
    loadIfExists(onDone?: (loaded: boolean) => void): false | void;
    saveColumnAsync(): Promise<unknown>;
    loadColumn(onDone?: Function): void;
    loadColumnAsync(): Promise<unknown>;
    unLoadColumn(onDone: (done: boolean) => void): false | void;
    columnExists(onDone?: (exists: boolean) => void): void;
    loadRegionHeader(onDone?: (success: boolean) => void): void;
    loadRegionHeaderAsync(): Promise<unknown>;
    columnExistsAsync(): Promise<boolean>;
    columnTimestamp(onDone?: (timestamp: number) => void): void;
    columnTimestampAsync(): Promise<number>;
    unLoadAllOutsideRadius(radius: number, run?: (column: ColumnDataTool) => boolean, onDone?: Function): void;
    unLoadAllColumnsAsync(): Promise<unknown>;
    unLoadAllColumns(onDone?: Function): void;
    allColumns(run: (column: ColumnDataTool) => void): void;
    getAllUnStoredColumns(run: (dimension: string, x: number, y: number, z: number) => void): void;
}
