import { DVEKernelWASM as WASMModule } from "./kernel.js";
export var DVEKernelFunctions;
(function (DVEKernelFunctions) {
    DVEKernelFunctions["SABTest"] = "sabTest";
    DVEKernelFunctions["DBOToBuffer"] = "dboToBuffer";
    DVEKernelFunctions["DVE_BRIDGE_RUN_WORLD_SUN_LIGHT"] = "DVE_BRIDGE_RUN_WORLD_SUN_LIGHT";
    DVEKernelFunctions["DVE_BRIDGE_REMOVE_RGB_LIGHT"] = "DVE_BRIDGE_REMOVE_RGB_LIGHT";
    DVEKernelFunctions["DVE_BRIDGE_UPDATE_RGB_LIGHT"] = "DVE_BRIDGE_UPDATE_RGB_LIGHT";
    DVEKernelFunctions["DVE_BRIDGE_REMOVE_SUN_LIGHT"] = "DVE_BRIDGE_REMOVE_SUN_LIGHT";
    DVEKernelFunctions["DVE_BRIDGE_UPDATE_SUN_LIGHT"] = "DVE_BRIDGE_UPDATE_SUN_LIGHT";
    DVEKernelFunctions["DVE_BRIDGE_SYNC_VOXEL_TAGS"] = "DVE_BRIDGE_SYNC_VOXEL_TAGS";
    DVEKernelFunctions["DVE_BRIDGE_SYNC_VOXEL_PALETTE"] = "DVE_BRIDGE_SYNC_VOXEL_PALETTE";
    DVEKernelFunctions["DVE_BRIDGE_SYNC_VOXEL_SUBSTANCE_PALETTE"] = "DVE_BRIDGE_SYNC_VOXEL_SUBSTANCE_PALETTE";
    DVEKernelFunctions["DVE_BRIDGE_SYNC_VOXEL_SUBSTANCE_TAGS"] = "DVE_BRIDGE_SYNC_VOXEL_SUBSTANCE_TAGS";
    DVEKernelFunctions["DVE_BRIDGE_SYNC_CHUNK_TAGS"] = "DVE_BRIDGE_SYNC_CHUNK_TAGS";
    DVEKernelFunctions["DVE_BRIDGE_SYNC_CHUNK"] = "DVE_BRIDGE_SYNC_CHUNK";
    DVEKernelFunctions["DVE_BRIDGE_UN_SYNC_CHUNK"] = "DVE_BRIDGE_UN_SYNC_CHUNK";
    DVEKernelFunctions["DVE_BRIDGE_SYNC_COLUMN_TAGS"] = "DVE_BRIDGE_SYNC_COLUMN_TAGS";
    DVEKernelFunctions["DVE_BRIDGE_SYNC_COLUMN"] = "DVE_BRIDGE_SYNC_COLUMN";
    DVEKernelFunctions["DVE_BRIDGE_UN_SYNC_COLUMN"] = "DVE_BRIDGE_UN_SYNC_COLUMN";
    DVEKernelFunctions["DVE_BRIDGE_SYNC_REGION_TAGS"] = "DVE_BRIDGE_SYNC_REGION_TAGS";
    DVEKernelFunctions["DVE_BRIDGE_SYNC_REGION"] = "DVE_BRIDGE_SYNC_REGION";
    DVEKernelFunctions["DVE_BRIDGE_UN_SYNC_REGION"] = "DVE_BRIDGE_UN_SYNC_REGION";
})(DVEKernelFunctions || (DVEKernelFunctions = {}));
class FunctionWrap {
    constructor(data) {
        return Object.assign(this, data);
    }
    call(args) {
        return module.ccall(this.name, this.returnType, this.arguments, args);
    }
}
let module;
let functionsMap = {};
export class DVEKernel {
    static call(funcionName, ...args) {
        return functionsMap[funcionName].call(args);
    }
    static init() {
        return new Promise(async (resolve) => {
            const resoledModule = await WASMModule();
            module = resoledModule;
            resolve(true);
        });
    }
}
const functions = [
    {
        name: DVEKernelFunctions.DBOToBuffer,
        arguments: ["array", "number"],
        returnType: "number",
    },
    {
        name: DVEKernelFunctions.SABTest,
        arguments: ["number", "number"],
        returnType: "number",
    },
    {
        name: DVEKernelFunctions.DVE_BRIDGE_RUN_WORLD_SUN_LIGHT,
        arguments: [],
        returnType: "number",
    },
    {
        name: DVEKernelFunctions.DVE_BRIDGE_REMOVE_RGB_LIGHT,
        arguments: [],
        returnType: "number",
    },
    {
        name: DVEKernelFunctions.DVE_BRIDGE_UPDATE_RGB_LIGHT,
        arguments: [],
        returnType: "number",
    },
    {
        name: DVEKernelFunctions.DVE_BRIDGE_REMOVE_SUN_LIGHT,
        arguments: [],
        returnType: "number",
    },
    {
        name: DVEKernelFunctions.DVE_BRIDGE_UPDATE_SUN_LIGHT,
        arguments: [],
        returnType: "number",
    },
    {
        name: DVEKernelFunctions.DVE_BRIDGE_SYNC_VOXEL_TAGS,
        arguments: [],
        returnType: "number",
    },
    {
        name: DVEKernelFunctions.DVE_BRIDGE_SYNC_VOXEL_PALETTE,
        arguments: [],
        returnType: "number",
    },
    {
        name: DVEKernelFunctions.DVE_BRIDGE_SYNC_VOXEL_SUBSTANCE_PALETTE,
        arguments: [],
        returnType: "number",
    },
    {
        name: DVEKernelFunctions.DVE_BRIDGE_SYNC_VOXEL_SUBSTANCE_TAGS,
        arguments: [],
        returnType: "number",
    },
    {
        name: DVEKernelFunctions.DVE_BRIDGE_SYNC_CHUNK_TAGS,
        arguments: [],
        returnType: "number",
    },
    {
        name: DVEKernelFunctions.DVE_BRIDGE_SYNC_CHUNK,
        arguments: [],
        returnType: "number",
    },
    {
        name: DVEKernelFunctions.DVE_BRIDGE_UN_SYNC_CHUNK,
        arguments: [],
        returnType: "number",
    },
    {
        name: DVEKernelFunctions.DVE_BRIDGE_SYNC_COLUMN_TAGS,
        arguments: [],
        returnType: "number",
    },
    {
        name: DVEKernelFunctions.DVE_BRIDGE_SYNC_COLUMN,
        arguments: [],
        returnType: "number",
    },
    {
        name: DVEKernelFunctions.DVE_BRIDGE_UN_SYNC_COLUMN,
        arguments: [],
        returnType: "number",
    },
    {
        name: DVEKernelFunctions.DVE_BRIDGE_SYNC_REGION_TAGS,
        arguments: [],
        returnType: "number",
    },
    {
        name: DVEKernelFunctions.DVE_BRIDGE_SYNC_REGION,
        arguments: [],
        returnType: "number",
    },
    {
        name: DVEKernelFunctions.DVE_BRIDGE_UN_SYNC_REGION,
        arguments: [],
        returnType: "number",
    },
];
for (const func of functions) {
    functionsMap[func.name] = new FunctionWrap(func);
}
