import type { TextureData, TextureTypeUVMap } from "./Texture.types";
import { TextureType } from "./TextureType.js";
import { ConstructorTextureData } from "./Constructor.types";
export declare const TextureManager: {
    defaultTexturePath: string;
    textureTypes: Map<string, TextureType>;
    getTextureIndex(data: ConstructorTextureData, overlay?: boolean): number;
    _ready: boolean;
    isReady(): boolean;
    $INIT(): Promise<void>;
    $START_ANIMATIONS(): void;
    generateTextureUVMap(): TextureTypeUVMap;
    defineDefaultTexturePath(path: string): void;
    getTextureData([type, id, segment]: ConstructorTextureData): TextureData | undefined;
    getTextureType(id: string): false | TextureType;
    addTextureType(id: string): TextureType;
    clearTextureData(): void;
    registerTexture(textureData: TextureData | TextureData[]): void;
    createRawDataMap(): Promise<Map<string, Uint8ClampedArray>>;
};
