import type { Vec3Array } from "@divinevoxel/core/Math";
export declare class DataMatrix<T> {
    size: Vec3Array;
    defaultValue: T;
    private _matrix;
    constructor(size: Vec3Array, defaultValue: T);
    get sizeX(): number;
    get sizeY(): number;
    get sizeZ(): number;
    setMatrix(matrix: T[][][]): void;
    cloneMatrix(): T[][][];
    setVec3([x, y, z]: Vec3Array, value: T): void;
    setXYZ(x: number, y: number, z: number, value: T): void;
    getVec3([x, y, z]: Vec3Array): T | undefined;
    getXYZ(x: number, y: number, z: number): T | undefined;
    deleteVec3([x, y, z]: Vec3Array): void;
    deleteXYZ(x: number, y: number, z: number): void;
    setAll(value: T): void;
    getAll(): Generator<[Vec3Array, T]>;
    swap(startPosition: Vec3Array, endPosition: Vec3Array): void;
    isCube(): boolean;
    private isWithinBounds;
}
